Summary: Tools and servers for the SNMP protocol
Name: op5-trapper-collector
Version: %{op5version}
Release: %{op5release}%{?dist}
License: GPLv2
Group: op5/trapper
Vendor: op5 AB
Source: %name-%version.tar.gz
Source1: init.patch
Prefix: /opt/trapper
Requires: openssl
%if 0%{?rhel} <= 6
BuildRequires: mysql-devel
%else
BuildRequires: mariadb-devel
%{?systemd_requires}
BuildRequires: systemd
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}
Packager: build@op5
Requires: openssl, popt, zlib, glibc
Requires: op5-mysql
Requires: op5-monitor-user
BuildRequires: openssl-devel
%if 0%{?suse_version}
BuildRequires: libmysqlclient-devel
BuildRequires: bzip2
Requires: bzip2
%else
BuildRequires: bzip2-libs
BuildRequires: bzip2-devel
%endif


%description

Net-SNMP package compiled with MySQL support, stripped down to 
only one function of recieving the traps and configured to work
as part of op5 trapper solution.


%prep
rm --recursive --force %buildroot
%setup -q
%if 0%{?suse_version}
patch -p1 < %_sourcedir/init.patch
%endif


%build
make

%install
make INSTALL_TOP=%{buildroot}/%{prefix} install
%if 0%{?rhel} <= 6
mkdir --parents %{buildroot}/%{_initddir}
mv %{buildroot}/%{prefix}/etc/init.d/collector %{buildroot}/%{_initddir}/collector
rm --force %{buildroot}/%{prefix}/etc/systemd/collector.service
%else
mkdir --parents %{buildroot}%{_unitdir}
mv %{buildroot}/%{prefix}/etc/systemd/collector.service %{buildroot}/%{_unitdir}/collector.service
rm --force %{buildroot}/%{prefix}/etc/init.d/collector
%endif


%post
if [ -z "$(mysql -N -s -e 'SHOW DATABASES LIKE "trapper"')" ]; then
	mysql -e "create database trapper"
fi
if [ -z "$(mysql -t mysql -e "select user from user where user = 'trapper'")" ]
then
	mysql -e "create user 'trapper'@'localhost' identified by 'trapper'"
	mysql -e "grant all privileges on *.* to 'trapper'@'localhost'"
fi
mysql trapper < %{prefix}/share/db/collector.sql

mkdir --parents %{prefix}/share/snmp
ln --symbolic /usr/share/snmp/mibs %{prefix}/share/snmp/mibs

if [ "$1" -eq 1 ]; then
	echo "Disabling system's snmptrapd, if running..."
	service snmptrapd stop >/dev/null 2>&1 || :
	chkconfig --del snmptrapd >/dev/null 2>&1 || :
fi

%if 0%{?rhel} <= 6
chkconfig --add collector
service collector stop 2>/dev/null || :
service collector start
%else
%systemd_post collector.service
%endif

# run ldconfig
PATH="$PATH:/sbin" ldconfig -n %{prefix}/lib

# In case we're upgrading, we probably have to insert the
# agentuser line into the config file
if ! grep --ignore-case --quiet ^agentuser %{prefix}/etc/collector.conf; then
	echo "agentuser monitor" >> %{prefix}/etc/collector.conf
fi


%preun
%if 0%{?rhel} <= 6
if [ "$1" -eq 0 ]; then
	chkconfig --del collector
	service collector stop
fi
%else
%systemd_preun collector.service
%endif


%postun
PATH="$PATH:/sbin" ldconfig -n %{prefix}/lib

%if 0%{?rhel} >= 7
%systemd_postun_with_restart collector.service
%endif


%clean
rm --recursive --force %buildroot


%files
%defattr(-,root,root)
%config(noreplace) %{prefix}/etc/collector.conf
%if 0%{?rhel} <= 6
%attr(755,root,root) %{_initddir}/collector
%else
%attr(644,root,root) %{_unitdir}/collector.service
%endif
%attr(755,root,root) %{prefix}/bin/*
%{prefix}/lib/*
%{prefix}/share/db/collector.sql
%{prefix}/share/doc/collector/license
%attr(750, monitor, root) %dir %{prefix}/var/run


%changelog
* Thu Nov 2 2017 Robin Engström <robin.engstrom@op5.com>
- Add collector service file to package
